/*
 * Catching Thrown and Caught Exceptions in C++ Using GDB
 * by Javantea
 * Oct 30, 2015
 * 
 * Very easy, just use catch throw.
 * 
(gdb) catch throw
Catchpoint 1 (throw)
(gdb) run
Starting program: /home/jvoss/recent/pfm/projects/fuzz/scratch/jfuzz/exception 
Catchpoint 1 (exception thrown), 0x00007ffff7b2a0f0 in __cxa_throw () from /usr/lib64/libstdc++.so.6
(gdb) bt
#0  0x00007ffff7b2a0f0 in __cxa_throw () from /usr/lib64/libstdc++.so.6
#1  0x0000000000400f24 in main (argc=1, argv=0x7fffffffd308) at exception.cpp:9
(gdb) c
Continuing.
Exception caught. test
[Inferior 1 (process 9090) exited normally]
(gdb) quit

 */
#include <iostream>
#include <exception>
#include <string>

int main(int argc, char **argv)
{
	try {
		throw std::string("test");
	} catch (std::string e) {
		std::cout << "Exception caught. " << e << std::endl;
	}
	return 0;
}
