#include "jrsfuzz.h"
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

/*
 * Run Javantea's fuzzer on a file you provide.
 * If you don't want to use a file input, try the string version.
 * 
 */
int main(int argc, char **argv)
{
	char *data = 0;
	long data_len = 0;
	if(argc <= 1)
	{
		fprintf(stderr, "Usage: jrsfuzzfile filename\n");
		exit(1);
	}
	char *filename = argv[1];
	FILE *f = fopen(filename, "rb");
	fseek(f, 0, SEEK_END);
	data_len = ftell(f);
	fseek(f, 0, SEEK_SET);
	// 4 GB should be enough for anyone... If not, remove this at your own 
	// risk.
	if(data_len >= 0x100000000)
	{
		fprintf(stderr, "File is much too large (max 4GB)\n");
		exit(1);
	}
	data = malloc(data_len);
	if(data == 0)
	{
		perror("malloc");
		exit(1);
	}
	size_t objs_read = fread(data, data_len, 1, f);
	if(objs_read != 1)
	{
		fprintf(stderr, "Warning: file did not give us what we wanted.\n");
	}

	// TODO: Test on 32, 64 diff archs and so on.
	long i;
	for(i = 0; i < 256 * data_len; i++)
	{
		char *r = JRSFuzz(data, data_len, i);
		if(r == 0)
		{
			perror("JRSFuzz");
			return 1;
		}
		fwrite(r, data_len, 1, stdout);
		// Free the return value.
		free(r);
	}
	return 0;
}
