#!/usr/bin/env python3
"""
TCP/IPv4 Fuzzer using JRSFuzz
by Javantea
April 13, 2016
DNS Fuzzer using JRSFuzz
by Javantea
Oct 11, 2015
Based on SMTP Fuzzer using JRSFuzz
by Javantea
Oct 11, 2015
Based on SMTP Grammar Fuzzer
by Javantea
Sept 14, 2015

A questionable dumb fuzzer for TCP/IPv4. It's a mutation fuzzer.
Provide the following values to fuzz a binary file you have captured:
python3 tcp_jrsfuzz1.py host port filename

If you get family problems, try forcing the family using -4 or -6 for IPv4 
or IPv6.

TODO:
Random syn
Handle errors returned by the server.
Monitors with GDB and ASAN integration.
"""
from __future__ import print_function
import jrsfuzz
import sys
import socket
import select
import binascii
from scapy.all import send, IP, TCP, UDP
unhexlify = binascii.unhexlify

def main():
	# This a TCP SYN to a certain IP, replace with IP of your choosing.
	# Don't blame me if you do something you weren't intending.
	#data = binascii.unhexlify('4500003c2cb440004006d1c7ac1709c748a53dbd' + '8555699bb2aa940c00000000a002111c3c6f0000020405b40402080a0025b8b80000000001030307')
	src = socket.inet_pton(socket.AF_INET, '192.168.88.3')
	dst = socket.inet_pton(socket.AF_INET, '216.218.134.11') # 192.168.88.1
	data = unhexlify('45000028000100004006497a') + src + dst + unhexlify('04d20050000000000000000050022000596b0000')

	host, port = 'localhost', 80
	family = socket.AF_UNSPEC
	socktype = socket.SOCK_RAW
	if '-4' in sys.argv:
		family = socket.AF_INET
		sys.argv.remove('-4')
	#end if
	if '-6' in sys.argv:
		family = socket.AF_INET6
		sys.argv.remove('-6')
	#end if
	if len(sys.argv) > 1:
			host = sys.argv[1]
	#end if
	if len(sys.argv) > 2:
			port = int(sys.argv[2])
	#end if
	#dest = (host, port)
	#gai = socket.getaddrinfo(host, port, family, socktype)
	
	if len(sys.argv) > 3:
		filename = sys.argv[3]
		data = open(filename, 'rb').read()
	#end if
	lines_output = len(data) * 256
	print("%i outputs, %3.3f MB" % (lines_output, lines_output*len(data)/(1<<20)), file=sys.stderr)

	"""
	our_data = None
	for family, socktype, proto, canonname, addr in gai:
		try:
			s = socket.socket(family, socktype, proto)
			#s.connect(addr)
		except Exception as e:
			print(e,)
			continue
		#end try
		our_data = (family, socktype, proto, canonname, addr)
		break
	#next family, socktype, proto, canonname, addr
	
	if our_data == None:
		print("Can't connect to dest", dest)
		return 1
	#end if
	family, socktype, proto, canonname, addr = our_data
	"""
	
	prevResp = None
	for i in range(lines_output):
		x = jrsfuzz.JRSFuzz(data, i)
		#print(x)
		#break
		# We might be sending 2 commands, but let it be.
		try:
			send(IP(x))
		except Exception as e:
			print(repr(x))
			print(e)
		#end try
	#next i
#end def main()

if __name__ == '__main__':
	main()
#end if
