#!/usr/bin/env python3
"""
Torrent Fuzzer using JRSFuzz
by Javantea
Nov 14, 2015
Based on PDF Fuzzer using JRSFuzz
by Javantea
Oct 29, 2015
DNS Fuzzer using JRSFuzz
by Javantea
Oct 11, 2015
SMTP Fuzzer using JRSFuzz
by Javantea
Oct 11, 2015
SMTP Grammar Fuzzer
by Javantea
Sept 14, 2015

A very reasonable dumb fuzzer for Torrent. It's a mutation fuzzer.
Provide the following values to fuzz a binary file you have captured:
python3 torrent_jrsfuzz1.py filename

TODO:
Handle errors.
Monitors with GDB and ASAN integration.
"""
from __future__ import print_function
import jrsfuzz
import sys
import debug1
import time
import tempfile
import libtorrent

def main():
	# This works on any Torrent file.
	data = b'%'
	if len(sys.argv) > 1:
		filename = sys.argv[1]
		data = open(filename, 'rb').read()
	#end if
	lines_output = len(data) * 256
	print("%i outputs, %3.3f MB" % (lines_output, lines_output*len(data)/(1<<20)), file=sys.stderr)
	start, end = 0, lines_output
	if len(sys.argv) > 2:
		start = int(sys.argv[2])
	#end if
	if len(sys.argv) > 3:
		end = int(sys.argv[3])
	#end if
	if start > lines_output: start = lines_output-1
	if end > lines_output: end = lines_output

	#prevResp = None
	y = None
	for i in range(start, end):
		x = jrsfuzz.JRSFuzz(data, i)
		print(i)
		tstart = time.time()
		# TODO: more functions, more debugging.
		r = libtorrent.bdecode(x)
		tend = time.time()
		#if r: print(r)
		# Just figure out what it is.
		if r: print(type(r))
		if (tend-tstart) >= 3:
			print("Slow execution on iteration {}".format(i))
		#end if
	#next i
#end def main()

if __name__ == '__main__':
	main()
#end if
