#!/usr/bin/env python3
"""
Zlib Fuzzer using JRSFuzz
by Javantea
Nov 13, 2015
Based on JPEG Fuzzer using JRSFuzz
by Javantea
Nov 13, 2015
PDF Fuzzer using JRSFuzz
by Javantea
Oct 29, 2015
DNS Fuzzer using JRSFuzz
by Javantea
Oct 11, 2015
SMTP Fuzzer using JRSFuzz
by Javantea
Oct 11, 2015
SMTP Grammar Fuzzer
by Javantea
Sept 14, 2015

A very reasonable dumb fuzzer for Zlib. It's a mutation fuzzer.
Provide the following values to fuzz a binary file you have captured:
python3 zlib_jrsfuzz1.py filename

TODO:
Handle errors returned by the executable.
Monitors with GDB and ASAN integration.
"""
import jrsfuzz
import sys
import time
import tempfile
import zlib

def main():
	# This works on any JPEG file...
	data = b'%'
	if len(sys.argv) > 1:
		filename = sys.argv[1]
		data = open(filename, 'rb').read()
	#end if
	lines_output = len(data) * 256
	print("%i outputs, %3.3f MB" % (lines_output, lines_output*len(data)/(1<<20)), file=sys.stderr)
	start, end = 0, lines_output
	if len(sys.argv) > 2:
		start = int(sys.argv[2])
	#end if
	if len(sys.argv) > 3:
		end = int(sys.argv[3])
	#end if
	if start > lines_output: start = lines_output-1
	if end > lines_output: end = lines_output

	#prevResp = None
	for i in range(start, end):
		x = jrsfuzz.JRSFuzz(data, i)
		print(i)
		start = time.time()
		out = None
		try:
			out = zlib.decompress(x)
		except zlib.error as ze:
			print(ze)
		#end try
		if out != None: print("Got decompressed", len(out))
		end = time.time()
	#next i
#end def main()

if __name__ == '__main__':
	main()
#end if
